Package org.apache.sling.feature.maven.mojos.apis

# Class ApisConfiguration

java.lang.Object
org.apache.sling.feature.maven.mojos.apis.ApisConfiguration

public class ApisConfiguration extends Object
Configuration for creating the api jars. The configuration can be controlled by a JSON extension:

     {
       "license-report" : "PATH",
       "license-header" : "STRING or STRING ARRAY",
       "license-footer" : "STRING or STRING ARRAY",
       "license-defaults" : ["PATTERN", "PATTERN"],
       "javadoc-links" : ["LINK", "LINK"],
       "javadoc-classpath-removals" : ["LINK", "LINK"],
       "javadoc-classpath-highest-versions" : ["LINK", "LINK"],
       "javadoc-classpath-tops" : ["LINK", "LINK"],
       "javadoc-source-level" : "STRING",
       "api-version" : "STRING",
       "bundle-resource-folders" : ["STRING", "STRING"],
       "bundle-resources" : ["STRING", "STRING"],
       "region-mapping" : {
         "REGION" : "MAPPED_NAME"
       },
       "classifier-mapping" : {
         "CLASSIFIER" : "MAPPED_NAME"
       },
       "manifest-entries" : {
         "key" : "value"
       },
       "javadoc-extensions" : [
         "[[REGION_NAME]:][COMMA_SEPARATED_LIST_OF_ARTIFACT_EXTENSIONS"
       ]
     }

## Constructor Summary

Constructors
Constructor
Description
`ApisConfiguration(org.apache.sling.feature.Feature feature)`

## Method Summary

Modifier and Type
Method
Description
`Set<String>`
`getAdditionalJavadocExtensions(String regionName)`
Get the map for additional javadoc extensions for a region
`String`
`getApiName()`
`String`
`getApiVersion()`
`List<String>`
`getBundleResourceFolders()`
`List<String>`
`getBundleResources()`
`Set<String>`
`getDependencyRepositories()`
`Set<String>`
`getEnabledToggles()`
`List<String>`
`getJavadocClasspathHighestVersions()`
`List<String>`
`getJavadocClasspathRemovals()`
`List<String>`
`getJavadocClasspathTops()`
`List<String>`
`getJavadocLinks()`
`String`
`getJavadocSourceLevel()`
`String`
`getLicenseDefault(org.apache.sling.feature.ArtifactId id)`
`List<String>`
`getLicenseDefaults()`
`String`
`getLicenseReport()`
`String`
`getLicenseReportFooter()`
`String`
`getLicenseReportHeader()`
`Map<String,String>`
`getManifestEntries()`
`boolean`
`isGenerateJavadocForAllApi()`
`boolean`
`isUseApiDependencies()`
`boolean`
`isUseApiDependenciesForJavadoc()`
`void`
`logConfiguration(org.apache.maven.plugin.logging.Log log)`
`String`
`mapApiClassifier(String classifier)`
Apply classifier mapping if configured
`String`
`mapApiRegionName(String regionName)`
Apply region name mapping if configured
`void`
`setAdditionalJavadocExtensions(List<String> javadocAdditionalExtensions)`
Add the additional extensions for javadoc generation
`void`
`setApiName(String value)`
`void`
`setApiVersion(String apiVersionFromProject)`
`void`
`setBundleResourceFolders(String resourceFoldersFromProject)`
`void`
`setBundleResources(String[] includeResourcesFromProject)`
`void`
`setClassifierMappings(Map<String,String> valuesFromProject)`
`void`
`setDependencyRepositories(String list)`
Set the dependency repositories
`void`
`setEnabledToggles(String value)`
`void`
`setGenerateJavadocForAllApi(boolean generateJavadocForAllApi)`
`void`
`setJavadocClasspathHighestVersions(List<String> javadocClasspathHighestVersionsFromProject)`
`void`
`setJavadocClasspathRemovals(List<String> javadocClasspathRemovalsFromProject)`
`void`
`setJavadocClasspathTops(List<String> javadocClasspathTopsFromProject)`
`void`
`setJavadocLinks(String[] javadocLinksFromProject)`
`void`
`setJavadocSourceLevel(String javadocSourceLevelFromProject)`
`void`
`setLicenseDefaults(List<String> licenseDefaultsFromProjcect)`
`void`
`setLicenseReport(String licenseReportFromProjcect)`
`void`
`setLicenseReportFooter(String licenseReportFooterFromProjcect)`
`void`
`setLicenseReportHeader(String licenseReportHeaderFromProjcect)`
`void`
`setManifestEntries(Properties valuesFromProject)`
`void`
`setRegionMappings(Map<String,String> valuesFromProject)`
`void`
`setUseApiDependencies(boolean flag)`
`void`
`setUseApiDependenciesForJavadoc(boolean flag)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ApisConfiguration

public ApisConfiguration(org.apache.sling.feature.Feature feature) throws org.apache.maven.plugin.MojoExecutionException

Throws:
  `org.apache.maven.plugin.MojoExecutionException`

## Method Details

### logConfiguration

public void logConfiguration(org.apache.maven.plugin.logging.Log log)

### getBundleResources

public List<String> getBundleResources()

### getJavadocLinks

public List<String> getJavadocLinks()

### getJavadocSourceLevel

public String getJavadocSourceLevel()

### getApiVersion

public String getApiVersion()

### getApiName

public String getApiName()

### getBundleResourceFolders

public List<String> getBundleResourceFolders()

### getLicenseReport

public String getLicenseReport()

### getLicenseDefaults

public List<String> getLicenseDefaults()

### getLicenseReportHeader

public String getLicenseReportHeader()

### getLicenseReportFooter

public String getLicenseReportFooter()

### getManifestEntries

public Map<String,String> getManifestEntries()

### getJavadocClasspathRemovals

public List<String> getJavadocClasspathRemovals()

### getJavadocClasspathHighestVersions

public List<String> getJavadocClasspathHighestVersions()

### getJavadocClasspathTops

public List<String> getJavadocClasspathTops()

### mapApiRegionName

public String mapApiRegionName(String regionName)
Apply region name mapping if configured

Parameters:
  `regionName` - The region name
Returns:
  The mapped name or the original name

### mapApiClassifier

public String mapApiClassifier(String classifier)
Apply classifier mapping if configured

Parameters:
  `classifier` - The classifier
Returns:
  The mapped classifier or the original classifier

### getLicenseDefault

public String getLicenseDefault(org.apache.sling.feature.ArtifactId id)

### setLicenseDefaults

public void setLicenseDefaults(List<String> licenseDefaultsFromProjcect) throws org.apache.maven.plugin.MojoExecutionException

Throws:
  `org.apache.maven.plugin.MojoExecutionException`

### setLicenseReport

public void setLicenseReport(String licenseReportFromProjcect)

### setLicenseReportHeader

public void setLicenseReportHeader(String licenseReportHeaderFromProjcect)

### setLicenseReportFooter

public void setLicenseReportFooter(String licenseReportFooterFromProjcect)

### setJavadocLinks

public void setJavadocLinks(String[] javadocLinksFromProject)

### setJavadocClasspathRemovals

public void setJavadocClasspathRemovals(List<String> javadocClasspathRemovalsFromProject)

### setJavadocClasspathHighestVersions

public void setJavadocClasspathHighestVersions(List<String> javadocClasspathHighestVersionsFromProject)

### setJavadocClasspathTops

public void setJavadocClasspathTops(List<String> javadocClasspathTopsFromProject)

### setJavadocSourceLevel

public void setJavadocSourceLevel(String javadocSourceLevelFromProject)

### setApiVersion

public void setApiVersion(String apiVersionFromProject)

### setBundleResources

public void setBundleResources(String[] includeResourcesFromProject)

### setBundleResourceFolders

public void setBundleResourceFolders(String resourceFoldersFromProject)

### setRegionMappings

public void setRegionMappings(Map<String,String> valuesFromProject)

### setClassifierMappings

public void setClassifierMappings(Map<String,String> valuesFromProject)

### setManifestEntries

public void setManifestEntries(Properties valuesFromProject)

### setEnabledToggles

public void setEnabledToggles(String value)

### getEnabledToggles

public Set<String> getEnabledToggles()

### setAdditionalJavadocExtensions

public void setAdditionalJavadocExtensions(List<String> javadocAdditionalExtensions)
Add the additional extensions for javadoc generation

Parameters:
  `javadocAdditionalExtensions` - A list of strings

### getAdditionalJavadocExtensions

public Set<String> getAdditionalJavadocExtensions(String regionName)
Get the map for additional javadoc extensions for a region

Parameters:
  `regionName` - the region
Returns:
  The set of extension names, might be empty

### isUseApiDependencies

public boolean isUseApiDependencies()

Returns:
  the useApiDependencies

### setUseApiDependencies

public void setUseApiDependencies(boolean flag)

Parameters:
  `flag` - The value for useApiDependencies

### isUseApiDependenciesForJavadoc

public boolean isUseApiDependenciesForJavadoc()

Returns:
  the useApiDependenciesForJavadoc

### setUseApiDependenciesForJavadoc

public void setUseApiDependenciesForJavadoc(boolean flag)

Parameters:
  `flag` - The value for useApiDependenciesForJavadoc

### isGenerateJavadocForAllApi

public boolean isGenerateJavadocForAllApi()

Returns:
  the generateJavadocForAllApi

### setGenerateJavadocForAllApi

public void setGenerateJavadocForAllApi(boolean generateJavadocForAllApi)

Parameters:
  `generateJavadocForAllApi` - the generateJavadocForAllApi to set

### getDependencyRepositories

public Set<String> getDependencyRepositories()

### setDependencyRepositories

public void setDependencyRepositories(String list)
Set the dependency repositories

Parameters:
  `list` - Comma separated list or `null`

### setApiName

public void setApiName(String value)